---
title: Tempo Documentation
aliases:
  - /docs/tempo/
---

# Tempo Documentation

<p align="center"><img src="logo_and_name.png" alt="Tempo Logo"></p>

Grafana Tempo is an open source, easy-to-use and high-volume distributed tracing backend. Tempo is cost-efficient, requiring only object storage to operate, and is deeply integrated with Grafana, Prometheus, and Loki.

> **Note:** You can use [Grafana Cloud](https://grafana.com/products/cloud/features/#cloud-dashboards-grafana) to avoid installing, maintaining, and scaling your own instance of Grafana Tempo. The free forever plan includes 50GB of free traces. [Create an account to get started](https://grafana.com/auth/sign-up/create-user?pg=docs-tempo&plcmt=in-text).

- [Getting Started](getting-started/)
- [Configuration](configuration/)
- [Deployment and Operations](operations/)
- [API](api_docs/) 
- [Grafana Agent](grafana-agent/)
- [Troubleshooting](troubleshooting/)
- [Community](community/)
